<?php

class OrderProductModel {
  public $order_id;
  public $product_id;
  public $termination_id;
  public $amount;
  public $pos;
  public $description;
  public $price;
  public $price_setup;
  public $price_nne;
  public $price_nbe;
  public $billing_delay;
  public $billing_period;
  public $note;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new OrderProduct();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    if(!array_key_exists("note", $data)) {
      $model->note = "";
    }
    
    $me = new User();
    $me->loadMe();
    
    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("OrderProduct", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new OrderProduct($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("OrderProduct", "*", "1=1 ORDER BY order_id, pos, product_id, description");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new OrderProduct($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter = false) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("OrderProduct", "*", "$where ORDER BY order_id, pos, product_id, description");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new OrderProduct($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("OrderProduct", "*", "$where ORDER BY order_id, pos, product_id, description");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new OrderProduct($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    //var_dump($filter);exit;
    if(array_key_exists("order_id", $filter)) {
      $order_id = $filter['order_id'];
      if(is_numeric($order_id)) {
        $where .= " AND order_id=$order_id";
      }
    }
    
    if(array_key_exists("product_id", $filter)) {
      $product_id = $filter['product_id'];
      if(is_numeric($product_id)) {
        $where .= " AND order_id=$product_id";
      }
    }
    
    if(array_key_exists("termination_id", $filter)) {
      $termination_id = $filter['termination_id'];
      if(is_numeric($termination_id)) {
        $where .= " AND termination_id=$termination_id";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}